/*****************************************************
This program was produced by the
CodeWizardAVR V2.05.3 Standard
Automatic Program Generator
 Copyright 1998-2011 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 16.01.2012
Author  : PerTic@n
Company : If You Like This Software,Buy It
Comments: 


Chip type               : ATmega8
Program type            : Application
AVR Core Clock frequency: 8,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 256
*****************************************************/

#include <mega8.h>

// I2C Bus functions
#include <i2c.h>

// Standard Input/Output functions
#include <stdio.h>
//  
#include <delay.h> 

// Declare your global variables here
unsigned char str_out[32], str_out1[32], str_out2[32], str_out3[32];
volatile unsigned int result;
volatile unsigned char resM, resL, config;
void main(void)
{
unsigned int Uint, Udrop;
// Input/Output Ports initialization
// Port B initialization
PORTB=DDRB=0x00;
// Port C initialization
PORTC=DDRC=0x00;
// Port D initialization
PORTD=DDRD=0x00;
// Timer/Counter 0 initialization
TCCR0=0x00;
TCNT0=0x00;
// Timer/Counter 1 initialization
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;
// Timer/Counter 2 initialization
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;
// External Interrupt(s) initialization
MCUCR=0x00;
// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x00;
// USART Communication Parameters: 8 Data, 1 Stop, No Parity
// Receiver: Off  Transmitter: On Mode: Asynchronous  Baud Rate: 9600
UCSRA=0x00;
UCSRB=0x08;
UCSRC=0x86;
UBRRH=0x00;
UBRRL=0x33;
// Analog Comparator Off
ACSR=0x80;
SFIOR=0x00;
// ADC disabled
ADCSRA=0x00;
// SPI disabled
SPCR=0x00;
// TWI disabled
TWCR=0x00;

// I2C Bus initialization
// I2C Port: PORTB
// I2C SDA bit: 1
// I2C SCL bit: 0
// Bit Rate: 100 kHz
// Note: I2C settings are specified in the
// Project|Configure|C Compiler|Libraries|I2C menu.
sprintf(str_out,"   I2C \r");
puts(str_out);
i2c_init();
i2c_start(); //   I2C
i2c_write(0xD0); //    +   
i2c_write(0x90); //   : 12-,  , 240   . + 
i2c_stop(); //   I2C
sprintf(str_out,": 12  . \r");
puts(str_out);
delay_ms(5);
while (1)
      {
      result=0;
      i2c_start(); //   I2C  
      i2c_write(0xD1); //    +   
      resM=i2c_read(1); //    
      result = (0x07 & resM);//     
      resL=i2c_read(1); //     
      result = (result << 8 )|(resL);//     
      config=i2c_read(0);
      i2c_stop();
      sprintf(str_out1," -:0x%02X \r",config);
      puts(str_out1);
      sprintf(str_out2,"  ADC: HB=0x%02X LB=0x%02X\r",resM,resL );
      puts(str_out2);
      sprintf(str_out3,"RESULT: HEX=%04X DEC=%-8d\r", result, result);
      puts(str_out3);
      if (result < 1000)
      {Uint=0;
      Udrop=result;}
      if (result >= 1000)
      {Uint=result/1000;
      Udrop=result%1000;}
      sprintf(str_out," : %1d,%03d \r", Uint, Udrop);
      puts(str_out);
      delay_ms(500);
      }
}
